#include <stdio.h>

#include "board.h"
#include "uct.h"
#include "rating.h"


/*------------------------------------------------------------------*/
/* 変数                                                             */
/*------------------------------------------------------------------*/

static struct game *main_game;


/*------------------------------------------------------------------*/
/* 初期化する関数                                                   */
/*------------------------------------------------------------------*/
int
clearboard( void )
{
	DoneGame( main_game );
	main_game = InitializeGame();
	InitializeUCTMove();

	return TRUE;
}


/*------------------------------------------------------------------*/
/* 次の手を返す                                                     */
/*------------------------------------------------------------------*/
int
genmove(int color)
{
	int pos;

	/* UCT */
	pos = UCTMove( main_game, color );

	if(main_game->moves == 1) pos = 84; // E5

	return pos;
}


/*------------------------------------------------------------------*/
/* 着手                                                             */
/*------------------------------------------------------------------*/
void
putstone(int color, int point)
{
	if(point != RESIGN){	// 投了でなかったら
		SetStone( main_game, color, point );
	}
}


/*------------------------------------------------------------------*/
/* 合法手の判定                                                     */
/*------------------------------------------------------------------*/
int
checklegal( int color, int pos )
{
	return CheckLegal(main_game, color, pos);
}


/*------------------------------------------------------------------*/
/* 勝敗                                                             */
/*------------------------------------------------------------------*/
int
finalscore( void )
{
	return ( (int)((double)BoardScore( main_game )-KOMI) );
}


/*------------------------------------------------------------------*/
/* 終了                                                             */
/*------------------------------------------------------------------*/
int
fin( void )
{
	/* メモリの解放 */
	DoneGame( main_game );

	return TRUE;
}